-dA enhancement
[official-gcc.git] / contrib / gcc_update
blobcc847fb6c389cd407621e8c6a9766ff09c4dcd13
1 #! /bin/sh
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
8 # 2011 Free Software Foundation
9 # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License. A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
34 # Examples:
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
51 ######## Anything below shouldn't be changed by regular users.
53 # Arrange for the value of $0 to be available for functions
54 self=$0
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60 if [ -z "$silent" ]; then
61 echo "$@"
65 # This function prints a list of all generated files, along with their
66 # dependencies. Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69 sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 # intl library
74 intl/plural.c: intl/plural.y
75 intl/configure: intl/configure.ac intl/aclocal.m4
76 intl/config.h.in: intl/configure.ac intl/aclocal.m4
77 # Now, proceed to gcc automatically generated files
78 gcc/configure: gcc/configure.ac
79 gcc/cstamp-h.in: gcc/configure.ac
80 gcc/config.in: gcc/cstamp-h.in
81 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
83 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-arches.def gcc/config/arm/arm-cores.def gcc/config/arm/genopt.sh
84 # And then, language-specific files
85 gcc/cp/cfns.h: gcc/cp/cfns.gperf
86 gcc/java/keyword.h: gcc/java/keyword.gperf
87 # testsuite
88 # Without this, _Pragma3.c can have a false negative.
89 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
90 # Similarly, without this, you will see:
91 # direct2s.c:35: warning: current file is older than direct2.c
92 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
93 # lto-plugin
94 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
95 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
96 # And libraries, at last
97 libbanshee/configure: libbanshee/configure.ac
98 libmudflap/configure: libmudflap/configure.ac
99 libobjc/configure: libobjc/configure.ac
100 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
101 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
102 zlib/configure: zlib/configure.ac zlib/aclocal.m4
103 fastjar/aclocal.m4: fastjar/configure.ac
104 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
105 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
106 boehm-gc/aclocal.m4: boehm-gc/configure.ac
107 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
108 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
109 libada/configure: libada/configure.ac
110 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
111 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
112 libffi/configure: libffi/configure.ac libffi/aclocal.m4
113 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
114 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
115 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
116 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
117 libjava/aclocal.m4: libjava/configure.ac
118 libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
119 libjava/configure: libjava/configure.ac libjava/aclocal.m4
120 libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
121 libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
122 libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
123 libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
124 libcpp/aclocal.m4: libcpp/configure.ac
125 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
126 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
127 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
128 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
129 libgomp/testsuite/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
130 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
131 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
132 # Top level
133 Makefile.in: Makefile.tpl Makefile.def
134 configure: configure.ac config/acx.m4
139 # This function touches generated files such that the ``end'' user does
140 # not have to rebuild them.
141 touch_files () {
142 rm -f Makefile.$$
143 echo 'all: \' > Makefile.$$
144 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
145 echo '; @true' >> Makefile.$$
146 files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
147 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
148 echo ':' >> Makefile.$$
149 echo ' @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
150 echo ' echo Touching $@...; \' >> Makefile.$$
151 chat ' echo Touching $@... 1>&2; \' >> Makefile.$$
152 echo ' touch $@' >> Makefile.$$
153 files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
155 # We would have to explicitly shut off the "Entering... Leaving..."
156 # messages through "--no-print-directory" to handle the case when
157 # we were called from a recursive invocation (i.e. "$(MAKE)" in a
158 # Makefile, not just make). Passing only "-s" doesn't help then,
159 # because make has helpfully added "-w" to MAKEFLAGS automatically.
160 # Unfortunately we do not require GNU make other than for building
161 # and testing, so let's just grep known text explicitly echoed by
162 # the rule.
163 while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
164 sleep 1
165 done 2>&1
166 rm -f Makefile.$$
170 # Whenever we update the tree or install a patch, we may be modifying
171 # this script. By re-execing it, we ensure that the appropriate
172 # dependencies and rules will be used.
173 touch_files_reexec () {
174 chat "Adjusting file timestamps"
175 exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
178 # This functions applies a patch to an existing tree.
179 apply_patch () {
180 if [ -f "$1" ]; then
181 echo "Applying patch file $1"
182 case $1 in
183 *gz)
184 gzip -d -c "$1" | patch -p1 ;;
185 *bz2)
186 bzip2 -d -c "$1" | patch -p1 ;;
188 patch -p1 < "$1";;
189 esac
191 touch_files_reexec
194 # Check whether this indeed looks like a local tree.
195 if [ ! -f gcc/version.c ]; then
196 echo "This does not seem to be a GCC tree!"
197 exit
200 case "$1" in
201 --silent)
202 silent=t
203 shift
205 esac
207 case "$1" in
208 # First of all, check whether we are going to process a patch.
209 --patch)
210 if test "$#" != 2; then
211 echo "$1" expects only one argument >&2
212 exit 1
214 apply_patch "${2}"
215 exit $?
218 --touch)
219 if test "$#" != 1; then
220 echo "$1" does not expect any argument >&2
221 exit 1
223 touch_files
224 exit $?
227 --list)
228 if test "$#" != 1; then
229 echo "$1" does not expect any argument >&2
230 exit 1
232 files_and_dependencies | sed 's/ /: /'
233 exit $?
236 --help)
237 sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
241 }' \
242 -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
243 exit $?
246 esac
248 # Check for known version control systems.
249 if [ -d .git ]; then
250 GCC_GIT=${GCC_GIT-${GIT-git}}
251 vcs_type="git"
252 elif [ -d .hg ]; then
253 GCC_HG=${GCC_HG-${HG-hg}}
254 vcs_type="hg"
255 elif [ -d .svn ]; then
256 GCC_SVN=${GCC_SVN-${SVN-svn}}
257 vcs_type="svn"
258 else
259 echo "This does not seem to be a GCC GIT/HG/SVN tree!"
260 exit
263 # Check command-line options
264 if [ x"${1}"x = x"--nostdflags"x ]; then
265 shift
266 else
267 set -- $UPDATE_OPTIONS ${1+"$@"}
270 case $vcs_type in
271 git)
272 chat "Updating GIT tree"
274 $GCC_GIT diff --quiet --exit-code HEAD
275 if [ $? -ne 0 ]; then
276 echo "Attempting to update a dirty git tree!" >&2
277 echo "Commit or stash your changes first and retry." >&2
278 exit 1
281 $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
282 if [ $? -ne 0 ]; then
283 (touch_files_reexec)
284 echo "git pull of full tree failed." >&2
285 exit 1
288 revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
289 branch=`$GCC_GIT name-rev --name-only HEAD || :`
293 chat "Updating HG tree"
295 # Add -q so untracked files aren't listed.
296 if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
297 echo "Attempting to update a dirty hg tree!" >&2
298 echo "Commit or revert your changes first and retry." >&2
299 exit 1
302 # Check for mq extension. mq patches must be popped so tip has
303 # been converted from the SVN tree.
304 if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
305 # FIXME: Perhaps pop queue instead? We could do that since we
306 # know the tree is clean.
307 echo "Attempting to update hg tree with mq patches applied!" >&2
308 echo "Pop your patches first and retry." >&2
309 exit 1
312 # Update tree, but make sure to only pull the default branch.
313 # Otherwise all branches in the upstream repo are added, even if
314 # only a single one has been cloned.
315 $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
316 if [ $? -ne 0 ]; then
317 (touch_files_reexec)
318 echo "hg pull of full tree failed." >&2
319 exit 1
322 # Update tree. Needs to be done separately from pull so
323 # gcc_update -rREV works.
324 $GCC_HG update ${silent+-q} ${1+"$@"}
325 if [ $? -ne 0 ]; then
326 (touch_files_reexec)
327 echo "hg update of full tree failed." >&2
328 exit 1
331 # Extract SVN revision corresponding to parents, as stored by
332 # hg convert. Before hg 1.4.3, there's no template keyword
333 # corresponding to the extra: tag, so need to use hg log --debug
334 # to extract the info.
335 parents=`$GCC_HG parents --template '{rev}'`
336 revision=`$GCC_HG log --debug -r$parents | \
337 sed -ne "/^extra:.*convert_revision=svn:/ {
338 s%^.*@%%
341 branch=`$GCC_HG branch`
342 # trunk in SVN parlance shows up as default branch in hg.
343 [ x$branch = x"default" ] && branch="trunk"
346 svn)
347 chat "Updating SVN tree"
349 $GCC_SVN ${silent+-q} --non-interactive update ${1+"$@"}
350 if [ $? -ne 0 ]; then
351 (touch_files_reexec)
352 echo "SVN update of full tree failed." >&2
353 exit 1
356 revision=`svn info | awk '/Revision:/ { print $2 }'`
357 branch=`svn info | sed -ne "/URL:/ {
358 s,.*/trunk,trunk,
359 s,.*/branches/,,
360 s,.*/tags/,,
364 esac
366 rm -f LAST_UPDATED gcc/REVISION
368 date
369 echo "`TZ=UTC date` (revision $revision)"
370 } > LAST_UPDATED
371 echo "[$branch revision $revision]" > gcc/REVISION
373 touch_files_reexec